"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fieldArrayApiPure = void 0;
var _common = require("./common");
var _lodash = _interopRequireDefault(require("lodash.get"));
var _lodash2 = _interopRequireDefault(require("lodash.clonedeep"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
var fieldArrayApiPure = function fieldArrayApiPure(set, get, path) {
  var _commonApiPure = (0, _common.commonApiPure)(set, get),
    setFieldArray = _commonApiPure.setFieldArray;
  var dynamicValues = (0, _lodash2["default"])(get().dynamicValues);
  var items = (0, _lodash["default"])(dynamicValues, path) || [];
  return {
    addItem: function addItem(data, index) {
      if (typeof index === 'undefined') {
        setFieldArray(path, [].concat(_toConsumableArray(items), [data]));
      } else {
        setFieldArray(path, items.splice(index, 0, data));
      }
    },
    removeItem: function removeItem(index) {
      items.splice(index, 1);
      setFieldArray(path, items);
    },
    moveItem: function moveItem(fromIndex, toIndex) {
      var item = items[fromIndex];
      items.splice(fromIndex, 1);
      items.splice(toIndex, 0, item);
      setFieldArray(path, items);
    },
    setItems: function setItems(items) {
      setFieldArray(path, items);
    },
    getItems: function getItems() {
      return items;
    }
  };
};
exports.fieldArrayApiPure = fieldArrayApiPure;