import React, { PropsWithoutRef } from 'react';
import { FieldRefProp } from '../../types';
export declare type GroupButtonsProps = React.ButtonHTMLAttributes<HTMLButtonElement>;
export declare type GroupPrevButtonProps = GroupButtonsProps;
export interface GroupNextButtonProps extends GroupButtonsProps {
    onSuccess?: () => void;
    onError?: () => void;
    autoSubmit?: boolean;
}
export interface GroupJumpButtonProps extends GroupButtonsProps {
    to: string;
}
export declare const GroupNext: {
    ({ onClick, children, uRef, autoSubmit, onSuccess, onError, ...props }: PropsWithoutRef<GroupNextButtonProps & FieldRefProp<HTMLButtonElement>>): JSX.Element;
    displayName: string;
};
export declare const GroupPrev: {
    ({ onClick, children, uRef, ...props }: PropsWithoutRef<GroupPrevButtonProps & FieldRefProp<HTMLButtonElement>>): JSX.Element;
    displayName: string;
};
export declare const GroupJump: {
    ({ onClick, to, children, uRef, ...props }: PropsWithoutRef<GroupJumpButtonProps & FieldRefProp<HTMLButtonElement>>): JSX.Element;
    displayName: string;
};
