"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GroupNav = void 0;
var _react = _interopRequireDefault(require("react"));
var _hooks = require("../../hooks");
var _classnames = _interopRequireDefault(require("classnames"));
var _excluded = ["onClickGroup", "clickNext", "clickPrev", "childNode", "uRef"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var GroupNavComponent = function GroupNavComponent(_ref) {
  var onClickGroup = _ref.onClickGroup,
    clickNext = _ref.clickNext,
    clickPrev = _ref.clickPrev,
    childNode = _ref.childNode,
    uRef = _ref.uRef,
    props = _objectWithoutProperties(_ref, _excluded);
  var _useGroups = (0, _hooks.useGroups)(),
    _useGroups2 = _slicedToArray(_useGroups, 2),
    groups = _useGroups2[0],
    groupsApi = _useGroups2[1];
  var _groupsApi$getClasses = groupsApi.getClasses(),
    active = _groupsApi$getClasses.active,
    valid = _groupsApi$getClasses.valid,
    touched = _groupsApi$getClasses.touched,
    disabled = _groupsApi$getClasses.disabled;
  return /*#__PURE__*/_react["default"].createElement("ul", _extends({}, props, {
    ref: uRef
  }), groups.map(function (group) {
    var _classNames;
    return /*#__PURE__*/_react["default"].createElement("li", {
      key: group.name,
      className: (0, _classnames["default"])((_classNames = {}, _defineProperty(_classNames, active, group.isActive), _defineProperty(_classNames, valid, group.isValid), _defineProperty(_classNames, touched, group.isTouched), _defineProperty(_classNames, disabled, group.isDisabled), _classNames)),
      onClick: function onClick() {
        var groupIndex = groups.findIndex(function (item) {
          return item.name === group.name;
        });
        var activeIndex = groups.findIndex(function (item) {
          return item.isActive;
        });
        if (onClickGroup) {
          onClickGroup(groupsApi.getGroup(group.name), groupsApi);
        }
        if (groupIndex < activeIndex && clickPrev || groupIndex > activeIndex && clickNext) {
          var _groupsApi$getGroup;
          (_groupsApi$getGroup = groupsApi.getGroup(group.name)) === null || _groupsApi$getGroup === void 0 ? void 0 : _groupsApi$getGroup.setActive();
        }
      }
    }, childNode ? childNode(groupsApi.getGroup(group.name), groupsApi) : group.name);
  }));
};
GroupNavComponent.displayName = 'GroupNav';
var GroupNav = GroupNavComponent;
exports.GroupNav = GroupNav;