import React, { PropsWithoutRef, ReactNode } from 'react';
import { FieldRefProp, GroupApiInterface, GroupsApiInterface } from '../../types';
export interface GroupState {
    name: string;
}
declare type GroupApiChildren = (group: GroupApiInterface, api: GroupsApiInterface) => ReactNode;
export interface GroupProps extends Omit<React.HTMLProps<HTMLDivElement>, 'children'> {
    name: string;
    defaultActive?: boolean;
    children: ReactNode | GroupApiChildren;
    displayAll?: boolean;
}
export declare const Group: {
    ({ name, children, defaultActive, displayAll, style, uRef, ...props }: PropsWithoutRef<GroupProps & FieldRefProp<HTMLDivElement>>): JSX.Element;
    displayName: string;
};
export declare const useGroupStore: {
    (): GroupState;
    <U>(selector: (state: GroupState) => U, equalityFn?: ((a: U, b: U) => boolean) | undefined): U;
};
export {};
