"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useGroupStore = exports.Group = void 0;
var _react = _interopRequireDefault(require("react"));
var _hooks = require("../../hooks");
var _zustand = require("zustand");
var _context = _interopRequireDefault(require("zustand/context"));
var _excluded = ["name", "children", "defaultActive", "displayAll", "style", "uRef"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var _createContext = (0, _context["default"])(),
  Provider = _createContext.Provider,
  useStore = _createContext.useStore;
var GroupComponent = function GroupComponent(_ref) {
  var name = _ref.name,
    children = _ref.children,
    defaultActive = _ref.defaultActive,
    displayAll = _ref.displayAll,
    style = _ref.style,
    uRef = _ref.uRef,
    props = _objectWithoutProperties(_ref, _excluded);
  var _useGroup = (0, _hooks.useGroup)(name, _objectSpread({
      defaultActive: defaultActive
    }, defaultActive ? {
      isTouched: true
    } : {})),
    _useGroup2 = _slicedToArray(_useGroup, 2),
    groupApi = _useGroup2[0],
    groupsAPi = _useGroup2[1];
  var newStyle = _objectSpread(_objectSpread({}, style), groupApi.isActive() || displayAll ? {} : {
    display: 'none'
  });
  var childrenComponent = typeof children === 'function' ? children(groupApi, groupsAPi) : children;
  return /*#__PURE__*/_react["default"].createElement(Provider, {
    createStore: function createStore() {
      return (0, _zustand.create)(function () {
        return {
          name: name
        };
      });
    }
  }, /*#__PURE__*/_react["default"].createElement("div", _extends({}, props, {
    ref: uRef,
    style: newStyle
  }), childrenComponent));
};
GroupComponent.displayName = 'Group';
var Group = GroupComponent;
exports.Group = Group;
var useGroupStore = useStore;
exports.useGroupStore = useGroupStore;