import React, { ChangeEvent, PropsWithoutRef, ReactNode } from 'react';
import { FieldPassedProps, FieldValueType, FormValues } from '../../types';
export interface CheckboxGroupApi {
    name: string;
    value: FieldValueType;
    disabled: boolean;
    onChange: (event: ChangeEvent) => void;
}
export interface CheckboxGroupProps {
    onChange?: (event: ChangeEvent) => void;
    children: ReactNode;
}
export declare const ContextCheckboxGroup: React.Context<CheckboxGroupApi | undefined>;
export declare const CheckboxGroup: {
    <Values extends FormValues>({ name, children, disabled, hideError, dependsOn, onChange, }: CheckboxGroupProps & FieldPassedProps<Values>): JSX.Element;
    displayName: string;
};
