"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ContextCheckboxGroup = exports.CheckboxGroup = void 0;
var _react = _interopRequireWildcard(require("react"));
var _helpers = require("../../helpers");
var _hooks = require("../../hooks");
var _fieldErrors = require("../extra/field-errors");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var ContextCheckboxGroup = /*#__PURE__*/(0, _react.createContext)(undefined);
exports.ContextCheckboxGroup = ContextCheckboxGroup;
var CheckboxGroupComponent = function CheckboxGroupComponent(_ref) {
  var name = _ref.name,
    children = _ref.children,
    disabled = _ref.disabled,
    hideError = _ref.hideError,
    dependsOn = _ref.dependsOn,
    _onChange = _ref.onChange;
  var _useField = (0, _hooks.useField)(name, {
      disabled: disabled,
      dependsOn: dependsOn
    }),
    _useField2 = _slicedToArray(_useField, 3),
    value = _useField2[0],
    setValue = _useField2[1],
    _useField2$ = _useField2[2],
    validate = _useField2$.validate,
    setTouched = _useField2$.setTouched;
  var childApi = {
    name: name,
    value: value,
    disabled: !!disabled,
    onChange: function onChange(event) {
      event.persist();
      var rawValue = event.currentTarget.getAttribute('value');
      var inputValue = rawValue ? (0, _helpers.jsonToValue)(rawValue) : null;
      var stateValue = value || [];
      var arrValue = stateValue.length > 0 && stateValue.includes(inputValue) ? stateValue.filter(function (item) {
        return item !== inputValue;
      }) : [].concat(_toConsumableArray(stateValue), [inputValue]);
      setValue(arrValue);
      validate();
      setTouched(); // TODO check
      if (_onChange) {
        _onChange(event);
      }
    }
  };
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(ContextCheckboxGroup.Provider, {
    value: childApi
  }, children), !hideError && /*#__PURE__*/_react["default"].createElement(_fieldErrors.FieldErrors, {
    name: name
  }));
};
CheckboxGroupComponent.displayName = 'CheckboxGroup';
var CheckboxGroup = CheckboxGroupComponent;
exports.CheckboxGroup = CheckboxGroup;