"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RadioGroupItem = void 0;
var _react = _interopRequireDefault(require("react"));
var _helpers = require("../../helpers");
var _radioGroup = require("./radio-group");
var _excluded = ["value", "uRef"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var RadioGroupItemComponent = function RadioGroupItemComponent(_ref) {
  var value = _ref.value,
    uRef = _ref.uRef,
    props = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/_react["default"].createElement(_radioGroup.ContextRadioGroup.Consumer, null, function (checkboxApi) {
    if (!checkboxApi) {
      console.error('Could not find Radio Group API. Make sure <RadioGroupItem/> is in the <RadioGroup/>.');
      return null;
    }
    var name = checkboxApi.name,
      stateValue = checkboxApi.value,
      disabled = checkboxApi.disabled,
      onChange = checkboxApi.onChange;
    return /*#__PURE__*/_react["default"].createElement("input", _extends({}, props, {
      ref: uRef,
      name: name,
      value: (0, _helpers.valueToJson)(value),
      checked: value === stateValue,
      type: "radio",
      onChange: onChange,
      disabled: disabled
    }));
  });
};
RadioGroupItemComponent.displayName = 'RadioGroupItem';
var RadioGroupItem = RadioGroupItemComponent;
exports.RadioGroupItem = RadioGroupItem;