import React, { ChangeEvent, PropsWithoutRef, ReactNode } from 'react';
import { FieldPassedProps, FieldValueType, FormValues } from '../../types';
export interface RadioGroupApi {
    name: string;
    value: FieldValueType;
    disabled: boolean;
    onChange: (event: ChangeEvent) => void;
}
export interface RadioGroupProps {
    onChange?: (event: ChangeEvent) => void;
    children: ReactNode;
}
export declare const ContextRadioGroup: React.Context<RadioGroupApi | undefined>;
export declare const RadioGroup: {
    <Values extends FormValues>({ name, children, disabled, hideError, onChange, dependsOn, }: RadioGroupProps & FieldPassedProps<Values>): JSX.Element;
    displayName: string;
};
