"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Radio = void 0;
var _react = _interopRequireDefault(require("react"));
var _hooks = require("../../hooks");
var _helpers = require("../../helpers");
var _excluded = ["name", "disabled", "onBlur", "onChange", "className", "value", "dependsOn", "uRef"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var RadioComponent = function RadioComponent(_ref) {
  var name = _ref.name,
    disabled = _ref.disabled,
    _onBlur = _ref.onBlur,
    _onChange = _ref.onChange,
    className = _ref.className,
    inputValue = _ref.value,
    dependsOn = _ref.dependsOn,
    uRef = _ref.uRef,
    props = _objectWithoutProperties(_ref, _excluded);
  var _useField = (0, _hooks.useField)(name, {
      disabled: disabled,
      dependsOn: dependsOn
    }),
    _useField2 = _slicedToArray(_useField, 3),
    value = _useField2[0],
    setValue = _useField2[1],
    _useField2$ = _useField2[2],
    getInputClassName = _useField2$.getInputClassName,
    validate = _useField2$.validate,
    setTouched = _useField2$.setTouched;
  return /*#__PURE__*/_react["default"].createElement("input", _extends({}, props, {
    name: name,
    type: "radio",
    ref: uRef,
    value: (0, _helpers.valueToJson)(value),
    checked: inputValue === value,
    disabled: disabled,
    className: getInputClassName(className),
    onChange: function onChange(event) {
      event.persist();
      setValue(inputValue);
      if (_onChange) {
        _onChange(event);
      }
    },
    onBlur: function onBlur(event) {
      event.persist();
      setTouched();
      validate();
      if (_onBlur) {
        _onBlur(event);
      }
    }
  }));
};
RadioComponent.displayName = 'Radio';
var Radio = RadioComponent;
exports.Radio = Radio;