"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Text = void 0;
var _react = _interopRequireWildcard(require("react"));
var _hooks = require("../../hooks");
var _helpers = require("../../helpers");
var _fieldErrors = require("../extra/field-errors");
var _excluded = ["name", "disabled", "onBlur", "onChange", "emptyValue", "className", "hideError", "dependsOn", "validateOnChange", "validateDelay", "onStopTyping", "stopTypingDelay", "uRef"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var TextComponent = function TextComponent(_ref) {
  var name = _ref.name,
    disabled = _ref.disabled,
    _onBlur = _ref.onBlur,
    _onChange = _ref.onChange,
    _ref$emptyValue = _ref.emptyValue,
    emptyValue = _ref$emptyValue === void 0 ? '' : _ref$emptyValue,
    className = _ref.className,
    hideError = _ref.hideError,
    dependsOn = _ref.dependsOn,
    validateOnChange = _ref.validateOnChange,
    validateDelay = _ref.validateDelay,
    onStopTyping = _ref.onStopTyping,
    stopTypingDelay = _ref.stopTypingDelay,
    uRef = _ref.uRef,
    props = _objectWithoutProperties(_ref, _excluded);
  var _useField = (0, _hooks.useField)(name, {
      disabled: disabled,
      dependsOn: dependsOn
    }),
    _useField2 = _slicedToArray(_useField, 3),
    value = _useField2[0],
    setValue = _useField2[1],
    _useField2$ = _useField2[2],
    getInputClassName = _useField2$.getInputClassName,
    validate = _useField2$.validate,
    setTouched = _useField2$.setTouched;
  (0, _react.useEffect)(function () {
    if (validateOnChange) {
      var timeOutId = setTimeout(function () {
        return validate();
      }, validateDelay || 500);
      return function () {
        return clearTimeout(timeOutId);
      };
    }
  }, [value]);
  (0, _react.useEffect)(function () {
    if (onStopTyping) {
      var timeOutId = setTimeout(function () {
        return onStopTyping();
      }, stopTypingDelay || 500);
      return function () {
        return clearTimeout(timeOutId);
      };
    }
  }, [value]);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("input", _extends({}, props, {
    name: name,
    ref: uRef,
    value: (0, _helpers.valueToString)(value, emptyValue),
    disabled: disabled,
    className: getInputClassName(className),
    onChange: function onChange(event) {
      event.persist();
      setValue((0, _helpers.stringToValue)(event.target.value, emptyValue));
      if (_onChange) {
        _onChange(event);
      }
    },
    onBlur: function onBlur(event) {
      event.persist();
      setTouched();
      validate();
      if (_onBlur) {
        _onBlur(event);
      }
    }
  })), !hideError && /*#__PURE__*/_react["default"].createElement(_fieldErrors.FieldErrors, {
    name: name
  }));
};
TextComponent.displayName = 'Text';
var Text = TextComponent;
exports.Text = Text;