"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.valueToString = exports.valueToJson = exports.stringToValue = exports.jsonToValue = exports.isPromise = exports.isArrayHasPromise = exports.isArrayEqual = exports.getValuesDiff = exports.generateId = void 0;
var _lodash = _interopRequireDefault(require("lodash.isequal"));
var _lodash2 = _interopRequireDefault(require("lodash.isempty"));
var _lodash3 = _interopRequireDefault(require("lodash.xorwith"));
var _lodash4 = _interopRequireDefault(require("lodash.transform"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var generateId = function generateId() {
  return Math.random().toString(36).substring(2);
};
exports.generateId = generateId;
var valueToString = function valueToString(value, emptyValue) {
  if (typeof value === 'undefined' || value === null || value === emptyValue) {
    return '';
  }
  return value.toString();
};
exports.valueToString = valueToString;
var stringToValue = function stringToValue(value, emptyValue) {
  return value === '' ? emptyValue : value;
};
exports.stringToValue = stringToValue;
var valueToJson = function valueToJson(value) {
  return JSON.stringify({
    v: value
  });
};
exports.valueToJson = valueToJson;
var jsonToValue = function jsonToValue(json) {
  var _JSON$parse = JSON.parse(json),
    v = _JSON$parse.v;
  return v;
};
exports.jsonToValue = jsonToValue;
var getValuesDiff = function getValuesDiff(prev, current, maxLevel) {
  var currentLevel = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 1;
  return (0, _lodash4["default"])(current, function (result, value, key) {
    if (prev[key] === undefined) {
      result[key] = value;
    } else if (!(0, _lodash["default"])(value, prev[key])) {
      result[key] = (value !== null && _typeof(value) === 'object' || Array.isArray(value)) && (!maxLevel || maxLevel && currentLevel < maxLevel) ? getValuesDiff(prev[key], value, maxLevel, currentLevel + 1) : value;
    }
  });
};
exports.getValuesDiff = getValuesDiff;
var isPromise = function isPromise(value) {
  return Boolean(value && typeof (value === null || value === void 0 ? void 0 : value.then) === 'function');
};
exports.isPromise = isPromise;
var isArrayHasPromise = function isArrayHasPromise(arr) {
  return arr.some(function (item) {
    return isPromise(item);
  });
};
exports.isArrayHasPromise = isArrayHasPromise;
var isArrayEqual = function isArrayEqual(x, y) {
  return (0, _lodash2["default"])((0, _lodash3["default"])(x, y, _lodash["default"]));
};
exports.isArrayEqual = isArrayEqual;