import { FieldApiInterface, FieldArrayApiInterface, FieldErrorsType, FieldValueType, FormApiInterface, FormValues, GroupApiInterface, GroupInterface, GroupsApiInterface, NestedKeys, UseFieldProps, UseGroupProps } from './types';
export declare const useForm: <Values extends FormValues>() => FormApiInterface<Values>;
export declare const useField: <Values extends FormValues>(fieldId: NestedKeys<Values>, props?: UseFieldProps) => [any, (value: FieldValueType) => void, FieldApiInterface, FormApiInterface<Values>];
export declare const useGroup: <Values extends FormValues>(groupName: string, props?: UseGroupProps) => [GroupApiInterface, GroupsApiInterface, FormApiInterface<Values>];
export declare const useGroups: <Values extends FormValues>() => [GroupInterface[], GroupsApiInterface, FormApiInterface<Values>];
export declare const useFieldValues: <Values extends FormValues>(fieldIds: NestedKeys<Values>[]) => Array<FieldValueType>;
export declare const useFieldValue: <Values extends FormValues>(fieldId: NestedKeys<Values>) => [FieldValueType | undefined, string | undefined];
export declare const useFieldErrors: <Values extends FormValues>(fieldId: NestedKeys<Values>) => [FieldErrorsType | undefined, string | undefined];
export declare const useFieldArray: <Values extends FormValues>(fieldArrayId: string) => [items: string[], fieldArrayApi: FieldArrayApiInterface, formApi: FormApiInterface<Values>];
